
fn main() {

	let mut a_vector = Vec::new();
	a_vector.push(2);
	a_vector.push(-2);
	a_vector.push(12);
	a_vector.push(20);
	
	println!("a_vector is: {:?}", a_vector);
	
	// Vectors can be accessed as arrays:
	println!("The first element of a_vector is {}", a_vector[0]);
	
	// Doing something with all Vector elements
	for x in a_vector.iter() {
		println!("{}", x);
	}
	
	for i in 0..a_vector.len()
	{
		println!("{}", a_vector[i]);
	}
	
	// This will crash the program!
	// println!("{}", a_vector[5]);
	
	// This will not crash it!
	match a_vector.get(5)
	{
		Some(x) => println!("The value of a_vector[5] is: {}", x),
		None => println!("a_vector[5] is not defined!")
	}
	
	for _ in 0..a_vector.len() {
		// let an_element = a_vector.pop();
		match a_vector.pop()
		{
			Some(x) => println!("x is {:?}", x),
			None => println!("It is not defined!")
		}
	}
	
	// This is not robust
	let an_element = a_vector.pop();
	println!("an_element is {:?}", an_element);
	
	// This is more robust
	match a_vector.pop()
	{
		Some(x) => println!("x is {:?}", x),
		None => println!("It is not defined!")
	}

}
