<?php

# Replace the Telegram bot token below with yours
$botToken = "215217314:AAEeUupMC12CGRL54v-JCKr6LJtoZBXH5mw";
$botUrl = "https://api.telegram.org/bot" . $botToken;
# Replace the LIFX API token below with yours
$lifxToken = "c92860b25d993aa62798716ab103469c83b4e9ce5800acd452c13f5bb92e61cf";
$lifxHeaders = array('Authorization: Bearer ' . $lifxToken);

function sendMessage ($chatId, $message) {
  # Sends messages from your bot
  global $botUrl;
  $url = $botUrl . "/sendmessage?chat_id=".$chatId."&text=".urlencode($message);
  file_get_contents($url);
}

function lifx_status($label) {
  # Retrieves the status of the lamp with a specified label
  global $lifxHeaders;
  $ch = curl_init();
  $url = "https://api.lifx.com/v1/lights/label:$label";
  curl_setopt($ch, CURLOPT_URL, $url);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
  curl_setopt($ch, CURLOPT_HTTPHEADER, $lifxHeaders);
  $json = json_decode(curl_exec($ch), true);
  if (!$json[0]["connected"]) {
    $status = "NC";
  } else {
    if ($json[0]["power"] == "on") {
      $status = "ON";
    } else {
      $status = "OFF";
    }
  }
  return $status;
}

function lifx_toggle($label) {
  # Toggle the lamp with the label specified
  global $lifxHeaders;
  $ch = curl_init();
  $url = "https://api.lifx.com/v1/lights/label:$label/toggle";
  curl_setopt($ch, CURLOPT_URL, $url);
  curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
  curl_setopt($ch, CURLOPT_HTTPHEADER, $lifxHeaders);
  $json = json_decode(curl_exec($ch), true);
  return $json["results"][0]["status"];
}

# Extract ID and text from the incoming Telegram message
$update = file_get_contents("php://input");
$update = json_decode($update, TRUE);
$chatId = $update["message"]["chat"]["id"];
$message = $update["message"]["text"];

# Define list of authorised Telegram users - replace with your chat ID
$authUsers = array("123456789");

if (in_array($chatId,$authUsers)) {

  switch($message) {
    # Check what message has been sent
    case "/start":  
      # Send a nice welcome message to authorised people
      sendMessage($chatId, "Hi and welcome to this tutorial bot!\n\nAllowed commands are:\n\n/lightstatus\tCheck Light Status\n/lighton\tSwitch Light On\n/lightoff\tSwitch Light Off\n");
      break;
    case "/lightstatus":
      # Check the status of the lamp
      switch(lifx_status("Landing")) {
        case "ON":
          $reply = "The light is switched on!";
          break;
        case "OFF":
          $reply = "The light is switched off!";
          break;
        case "NC":
          $reply = "ERROR: The light is not connected!";
          break;
      }
      sendMessage($chatId, $reply);
      break;
    case "/lighton":
      # Switch the light on (warn if already on)
      switch(lifx_status("Landing")) {
        case "ON":
          $reply = "ERROR: The light is already switched on!";
          break;
        case "OFF":
          if (lifx_toggle("Landing") == "ok") {
            $reply = "SUCCESS: Light switched on!";
          } else {
            $reply = "ERROR: Problem switching light on!";
          }
          break;
        case "NC":
          $reply = "ERROR: The light is not connected!";
          break;
      }
      sendMessage($chatId, $reply);
      break;
    case "/lightoff":
      # Switch the light off (warn if already off)
      switch(lifx_status("Landing")) {
        case "ON":
          if (lifx_toggle("Landing") == "ok") {
            $reply = "SUCCESS: Light switched off!";
          } else {
            $reply = "ERROR: Problem switching light off!";
          }
          break;
        case "OFF":
          $reply = "ERROR: Light already off!";
          break;
        case "NC":
          $reply = "ERROR: The light is not connected!";
          break;
      }
      sendMessage($chatId, $reply);
      break;
    default:
      # Catch-all for unknown commands
      sendMessage($chatId, "I don't understand you!!");
      break;
    }
} else {
  # Alert unauthorised senders, this could be obfuscated for improved security
  sendMessage($chatId, "I am not allowed to speak to strangers, sorry...\nYour chat ID is $chatId");
}
?>
